#version 330 core

#extension EXT_geometry_shader4:enable

uniform mat4 mvp;
uniform vec4 color;
uniform vec4 leftbottomfront;
uniform vec4 righttopback;

layout(points) in;
layout(line_strip , max_vertices=16) out;



 void main() {
	vec4 leftbottomback = vec4(leftbottomfront.x, leftbottomfront.y, righttopback.z, 1);
	vec4 rightbottomfront = vec4(righttopback.x, leftbottomfront.y , leftbottomfront.z, 1);
	vec4 rightbottomback = vec4(righttopback.x, leftbottomfront.y, righttopback.z, 1);
	
	vec4 righttopfront = vec4(righttopback.x, righttopback.y, leftbottomfront.z, 1);
	vec4 lefttopfront = vec4(leftbottomfront.x, righttopback.y, leftbottomfront.z, 1);
	vec4 lefttopback = vec4(leftbottomfront.x, righttopback.y, righttopback.z, 1);
	
	for(int i = 0; i < gl_VerticesIn; i++) {
		gl_Position = mvp * (gl_in[i].gl_Position + leftbottomfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + lefttopfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + righttopfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + righttopback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + lefttopback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + leftbottomback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + rightbottomback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + righttopback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + rightbottomback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + rightbottomfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + righttopfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + rightbottomfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + leftbottomfront);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + leftbottomback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + lefttopback);
		EmitVertex();
		gl_Position = mvp * (gl_in[i].gl_Position + lefttopfront);
		EmitVertex();
		EndPrimitive();
	}
  
}